Attribute VB_Name = "Interpreteur"
'Evaluateur par Carlvb
'ici 64 et 16 veulent dire qu'on n'valuera que des expressions
'ayant au plus 64 units lexicales et au plus 16 parenthses ouvrantes
'successives mais on peut les changer comme on veut
Private Const MaxToken As Integer = 64
Private Const MaxNiveau As Integer = 16
Public Tableau(1 To MaxNiveau, 1 To MaxToken), Reponse As Variant
Private Liste(1 To MaxToken), Ligne(1 To MaxToken) As String
Private Niveau, TopNiveau, Position, Rang, Longueur, Nombre, LigneMax, ColonneMax As Integer
Dim Unite, Token, CopieDeChaine As String
Dim Correct As Boolean

Public Function Evaluer(Expression As String) As Variant
Effacer
Expression = Compacter(Expression) 'Supprimer les symboles non signifiants...
Correct = Verifier(Expression)
If Not Correct Then Exit Function
Expression = Traduire(Expression) 'Remplacer les fonctions par des lettres exemple SIN=A,COS=B... pour simplifier la dcomposition
Decomposer Expression 'Dcomposer l'expression en units lexicales
If Not Correct Then Exit Function
Niveler 'Faire ressortir les niveaux de priorit modifi par les parenthses
If Not Correct Then Exit Function
Affiche 'C'est uniquement pour l'affichage,on peut l'enlever
Calculer 'Faire le calcul proprement dit
If Not Correct Then Exit Function
Reponse = Tableau(1, 1)
Effacer
If Val(Reponse) = 0 And Reponse <> "0" Then
    MsgBox "Erreur : fonction sans argument", vbCritical
    Exit Function
End If
Evaluer = Reponse
End Function

Public Function Compacter(Chaine As String) As String
Chaine = Replace(Chaine, " ", "") 'Supprimer les espaces
Chaine = Replace(Chaine, Chr(9), "") 'Supprimer les tabulations
Chaine = Replace(Chaine, Chr(13), "") 'Supprimer les retours charrits
'On peut ajouter d'autres caractres  supprimer
Compacter = Chaine
End Function

Private Sub Decomposer(Chaine As String)
Position = 1
Token = ""
For i = 1 To Len(Chaine) + 1
'Prendre les caractres un par un, si c'est un chiffre ou un sparateur de dcimal
'On reconstitue d'abord le nombre dans son intgralit avant de passer  l'oprateur suivant
'On stocke les units lexicales dans liste au fur et  mesure
    Unite = Left(Right(Chaine, Len(Chaine) - i + 1), 1)
    If Val(Unite) <> 0 Or Unite = "0" Or Unite = "." Then
        Token = Token & Unite
    Else
        If Token <> "" Then
            Liste(Position) = Token
            Position = Position + 1
        End If
        Liste(Position) = Unite
        Position = Position + 1
        Token = ""
        If Position > MaxToken Then
            MsgBox "Expression trop longue, essayez de fractionner le calcul", vbCritical
            Correct = False
            Exit Sub
        End If
    End If
Next
End Sub
Private Function Verifier(Chaine As String) As Boolean
CopieDeChaine = Chaine
'On peut ajouter  cette liste d'autres symboles valides mais il faut terminer la liste par "":chaine vide
ListeSymbole = Array("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ".", "+", "-", "*", "/", "(", ")", "^", "SIN", "COS", "TAN", "SQR", "LOG", "EXP", "ABS", "ATN", "RND", "PI", "")
Nombre = 1
'Pour compter le nombre de symbole de la liste
While ListeSymbole(Nombre) <> ""
    Nombre = Nombre + 1
Wend
'Eliminer tous les symboles valides de la liste dans l'expression
For i = 0 To Nombre
    CopieDeChaine = Replace(UCase(CopieDeChaine), ListeSymbole(i), "")
Next
'Si des caractres ne sont pas limins alors il y a une erreur
If CopieDeChaine = "" Then
    Verifier = True
Else
    Verifier = False
    MsgBox "Identificateur ou Fonction non connu : " & CopieDeChaine, vbCritical
End If
End Function

Private Function Traduire(Chaine As String) As String
'Ajouter  ces deux listes d' autres fonctions et leurs codes
'On peut utiliser d'autres codes que les lettres ex:#,,@,etc...
'if faut juste qu'ils ne comportent qu'un seul caractre sauf pou pi
'il faut terminer la liste par "":chaine vide
listefonction = Array("SIN", "COS", "TAN", "SQR", "LOG", "EXP", "ABS", "ATN", "RND", "PI", "")
ListeCodeFonction = Array("A", "B", "C", "D", "E", "F", "G", "H", "I", "3.1415926535897932384626433832795", "")
Nombre = 1
'Pour compter le nombre de Fonction de la liste
While listefonction(Nombre) <> ""
    Nombre = Nombre + 1
Wend
'Remplacer les Fonctions par leur code
For i = 0 To Nombre
    Chaine = Replace(UCase(Chaine), listefonction(i), ListeCodeFonction(i))
Next
Traduire = Chaine
End Function

Private Sub Niveler()
Niveau = 1
TopNiveau = 1
Position = 1
Rang = 1
While Liste(Position) <> ""
    If Liste(Position) = "(" Then
        'Une parenthse ouvrante accrot la priorit de l'expression qui la suit
        Niveau = Niveau + 1
        Position = Position + 1
        If Niveau >= MaxNiveau Then
            MsgBox "Trop de parenthses ouvrantes :( , essayez de faire le calcul en plusieurs temps", vbCritical
            Correct = False
            Exit Sub
        End If
    End If
    If Liste(Position) = ")" Then
        'Une parenthse fermante dcrot la priorit de l'expression qui la suit
        Niveau = Niveau - 1
        Position = Position + 1
        If Niveau <= 0 Then
            MsgBox "Trop de parenthses fermantes : )", vbCritical
            Correct = False
            Exit Sub
        End If
    End If
    'On continue sur le mme niveau s'il n'y a pas de parenthse
    If Liste(Position) <> "(" And Liste(Position) <> ")" Then
        Tableau(Niveau, Rang) = Liste(Position)
        Position = Position + 1
        Rang = Rang + 1
    End If
If Niveau > TopNiveau Then TopNiveau = Niveau
Wend
End Sub

Private Sub Calculer()
'Reperer la ligne le plus bas et le plus  droite dans Tableau
1: While TopNiveau > 0
    i = MaxToken
    While i > 1 And Tableau(TopNiveau, i) = ""
        i = i - 1
    Wend
    If i = 1 Then
        TopNiveau = TopNiveau - 1
        GoTo 1
    End If
'Mesurer la longueur de la ligne trouve
    Longueur = 0
    While Tableau(TopNiveau, i) <> "" And i > 1
        i = i - 1
        Longueur = Longueur + 1
    Wend
'Transfrer cette ligne dans une liste pour tre value
    NettoyerLigne
    If i > 1 Then
        For J = 1 To Longueur
            Ligne(J) = Tableau(TopNiveau, i + J)
        Next
    Else
        For J = 0 To Longueur
            Ligne(J + 1) = Tableau(TopNiveau, i + J)
        Next
    End If
'Evaluer la ligne qu'on a transfre
    repere = i
    If repere > 1 Then
        'La valeur de la ligne la remplace dans Tableau
        Tableau(TopNiveau - 1, repere + 1) = CalculerLigne
        If Not Correct Then Exit Sub
        Tableau(TopNiveau, repere + 1) = ""
        'On supprime la ligne qui vient d'tre value
        Reculer repere + 2, Longueur - 1
    Else
        'La valeur de la ligne la remplace dans Tableau
        Tableau(IIf(TopNiveau > 1, TopNiveau - 1, 1), repere) = CalculerLigne
        If Not Correct Then Exit Sub
        If TopNiveau <> 1 Then Tableau(TopNiveau, repere) = ""
        'On supprime la ligne qui vient d'tre value
        Reculer repere + 1, Longueur
    End If
Wend
End Sub
Private Function CalculerLigne() As Variant
On Error GoTo 8
 listefonction = Array("SIN", "COS", "TAN", "SQR", "LOG", "EXP", "ABS", "ATN", "RND", "PI", "")
  'On recherche d'abord les symboles ^:puissance
1: i = MaxToken
    While i > 1 And Ligne(i) <> "^"
        i = i - 1
    Wend
    If i = 1 And Ligne(1) = "" Then GoTo 2
    If i = 1 And Ligne(1) = "^" Then
        'fonction puissance au dbut d'une expression
        MsgBox "Erreur de syntaxe sur l'oprateur ^ ", vbCritical
        Correct = False
        Exit Function
    End If
    If i = 1 And Ligne(1) <> "" Then GoTo 2
    If (Val(Ligne(i - 1)) = 0 And Ligne(i - 1) <> "0") Or (Val(Ligne(i + 1)) = 0 And Ligne(i + 1) <> "0") Then
        MsgBox "Erreur d'argument sur l'oprateur ^ : " & Ligne(i - 1) & "^" & Ligne(i + 1), vbCritical
        Correct = False
        Exit Function
    Else
        
        Reponse = Val(Ligne(i - 1)) ^ Val(Ligne(i + 1))
        Ligne(i - 1) = Reponse
        Retour i, 2
        GoTo 1
    End If
'On recherche ensuite les symboles A  I: les fonctions
2:
 i = MaxToken
'65  73 reprsente les codes ascii des caractres A  I
    Caractere = IIf(Ligne(i) = "", "0", Ligne(i))
    While (Asc(Caractere) < 65 Or Asc(Caractere) > 73) And i > 1
        i = i - 1
    Caractere = IIf(Ligne(i) = "", "0", Ligne(i))
    Wend
    Caractere = IIf(Ligne(1) = "", "0", Ligne(i))
    If i = 1 And Ligne(1) = "" Then GoTo 3
    If i = 1 And Asc(Caractere) < 65 Or Asc(Caractere) > 73 Then GoTo 3
    If (Val(Ligne(i + 1)) = 0 And Ligne(i + 1) <> "0") Then
        MsgBox "Erreur d'argument sur la fonction " & listefonction(Asc(Ligne(i) - 65)) & ":" & listefonction(Asc(Ligne(i) - 65)) & Ligne(i + 1), vbCritical
        Correct = False
        Exit Function
    Else
        Select Case Ligne(i)
            Case "A"
                Reponse = Sin(Val(Ligne(i + 1)))
                Ligne(i) = Reponse
                Retour i + 1, 1
            Case "B"
                Reponse = Cos(Val(Ligne(i + 1)))
                Ligne(i) = Reponse
                Retour i + 1, 1
            Case "C"
                Reponse = Tan(Val(Ligne(i + 1)))
                Ligne(i) = Reponse
                Retour i + 1, 1
            Case "D"
                Reponse = Sqr(Val(Ligne(i + 1)))
                Ligne(i) = Reponse
                Retour i + 1, 1
            Case "E"
                Reponse = Log(Val(Ligne(i + 1)))
                Ligne(i) = Reponse
                Retour i + 1, 1
            Case "F"
                Reponse = Exp(Val(Ligne(i + 1)))
                Ligne(i) = Reponse
                Retour i + 1, 1
            Case "G"
                Reponse = Abs(Val(Ligne(i + 1)))
                Ligne(i) = Reponse
                Retour i + 1, 1
            Case "H"
                Reponse = Atn(Val(Ligne(i + 1)))
                Ligne(i) = Reponse
                Retour i + 1, 1
            Case "I"
                Randomize (Val(Ligne(1 + i)))
                Reponse = Rnd(Val(Ligne(1 + i)))
                Ligne(i) = Reponse
                Retour i + 1, 1
        End Select
    End If
    GoTo 2
'On recherche ensuite les symboles /: les divisions
3: i = MaxToken
    While i > 1 And Ligne(i) <> "/"
        i = i - 1
    Wend
    If i = 1 And Ligne(1) = "" Then GoTo 4
    If i = 1 And Ligne(1) = "/" Then
        MsgBox "Erreur de syntaxe sur l'oprateur / ", vbCritical
        Correct = False
        Exit Function
    End If
    If i = 1 And Ligne(1) <> "" Then GoTo 4
    If (Val(Ligne(i - 1)) = 0 And Ligne(i - 1) <> "0") Or (Val(Ligne(i + 1)) = 0 And Ligne(i + 1) <> "0") Then
        MsgBox "Erreur d'argument sur l'oprateur / : " & Ligne(i - 1) & "/" & Ligne(i + 1), vbCritical
        Correct = False
        Exit Function
    Else
        Reponse = Val(Ligne(i - 1)) / Val(Ligne(i + 1))
        Ligne(i - 1) = Reponse
        Retour i, 2
        GoTo 3
    End If
 'On recherche ensuite les symboles *: les multiplications
4: i = MaxToken
    While i > 1 And Ligne(i) <> "*"
        i = i - 1
    Wend
    If i = 1 And Ligne(1) = "" Then GoTo 5
    If i = 1 And Ligne(1) = "*" Then
        MsgBox "Erreur de syntaxe sur l'oprateur * ", vbCritical
        Correct = False
        Exit Function
    End If
    If i = 1 And Ligne(1) <> "" Then GoTo 5
    If (Val(Ligne(i - 1)) = 0 And Ligne(i - 1) <> "0") Or (Val(Ligne(i + 1)) = 0 And Ligne(i + 1) <> "0") Then
        MsgBox "Erreur d'argument sur l'oprateur * : " & Ligne(i - 1) & "*" & Ligne(i + 1), vbCritical
        Correct = False
        Exit Function
    Else
        Reponse = Val(Ligne(i - 1)) * Val(Ligne(i + 1))
        Ligne(i - 1) = Reponse
        Retour i, 2
        GoTo 4
    End If
'On recherche ensuite les symboles -: les soustractions
5: i = MaxToken
    While i > 1 And Ligne(i) <> "-"
        i = i - 1
    Wend
    If i = 1 And Ligne(1) = "" Then GoTo 6
    If i = 1 And Ligne(1) = "-" Then
        MsgBox "Erreur de syntaxe sur l'oprateur - ", vbCritical
        Correct = False
        Exit Function
    End If
    If i = 1 And Ligne(1) <> "" Then GoTo 6
    If (Val(Ligne(i - 1)) = 0 And Ligne(i - 1) <> "0") Or (Val(Ligne(i + 1)) = 0 And Ligne(i + 1) <> "0") Then
        MsgBox "Erreur d'argument sur l'oprateur - : " & Ligne(i - 1) & "-" & Ligne(i + 1), vbCritical
        Correct = False
        Exit Function
    Else
        Reponse = Val(Ligne(i - 1)) - Val(Ligne(i + 1))
        Ligne(i - 1) = Reponse
        Retour i, 2
        GoTo 5
    End If
  'On recherche ensuite les symboles +: les additions
6: i = MaxToken
    While i > 1 And Ligne(i) <> "+"
        i = i - 1
    Wend
    If i = 1 And Ligne(1) = "" Then GoTo 7
    If i = 1 And Ligne(1) = "+" Then
        MsgBox "Erreur de syntaxe sur l'oprateur + ", vbCritical
        Correct = False
        Exit Function
    End If
    If i = 1 And Ligne(1) <> "" Then GoTo 7
    If (Val(Ligne(i - 1)) = 0 And Ligne(i - 1) <> "0") Or (Val(Ligne(i + 1)) = 0 And Ligne(i + 1) <> "0") Then
        MsgBox "Erreur d'argument sur l'oprateur + : " & Ligne(i - 1) & "+" & Ligne(i + 1), vbCritical
        Correct = False
        Exit Function
    Else
        Reponse = Val(Ligne(i - 1)) + Val(Ligne(i + 1))
        Ligne(i - 1) = Reponse
        Retour i, 2
        GoTo 6
    End If
7:  CalculerLigne = (Ligne(1))
Exit Function
8:
    If Asc(Ligne(i)) > 64 And Asc(Ligne(i)) < 74 Then
        TypeCaractere = "la fonction "
        Ligne(i) = listefonction(Asc(Ligne(i)) - 65)
    Else
        TypeCaractere = "l'oprateur "
    End If
    Err.Description = Replace(Err.Description, " ou appel de procdure", "")
    MsgBox "Erreur sur " & TypeCaractere & Ligne(i) & " : " & Err.Description, vbCritical
    Err.Clear
    Correct = False
    Exit Function
End Function
    
Private Sub NettoyerLigne()
Erase Ligne
End Sub

Private Sub Retour(ByVal Debut As Integer, Taille As Integer)
'Pour supprimer les units lexicales dja valuer dans Ligne
    For i = Debut To MaxToken - Taille
        Ligne(i) = Ligne(i + Taille)
    Next
'Transformer les virgules en points sinon il y aura erreur
For i = 1 To MaxToken
        Ligne(i) = Replace(Ligne(i), ",", ".")
    Next
End Sub
Private Sub Reculer(Debut As Integer, ByVal Taille As Integer)
'Pour supprimer les lignes dja values dans Tableau
    For J = 1 To MaxNiveau
    For i = Debut To MaxToken - Taille
        Tableau(J, i) = Tableau(J, i + Taille)
    Next
    Next
'Transformer les virgules en points sinon il y aura erreur
    For i = 1 To MaxToken
    For J = 1 To TopNiveau
        Tableau(J, i) = Replace(Tableau(J, i), ",", ".")
    Next
    Next
End Sub
Private Sub Affiche()
On Error Resume Next
'C'est juste pour l'affichage mais c'est pas important
 listefonction = Array("SIN", "COS", "TAN", "SQR", "LOG", "EXP", "ABS", "ATN", "RND", "PI", "")
    Form1.Flex.Clear
    For i = 1 To TopNiveau
    For J = 1 To Rang
        Form1.Flex.TextMatrix(i - 1, J - 1) = Tableau(i, J)
        If Asc(Form1.Flex.TextMatrix(i - 1, J - 1)) > 64 And Asc(Form1.Flex.TextMatrix(i - 1, J - 1)) < 74 Then Form1.Flex.TextMatrix(i - 1, J - 1) = listefonction(Asc(Form1.Flex.TextMatrix(i - 1, J - 1)) - 65)
    Next
    Next
End Sub
Private Sub Effacer()
    Erase Tableau
    Erase Liste
    Erase Ligne
End Sub
